package com.spicysoft.sample.dribble;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.Log;
import android.view.MotionEvent;

import com.spicysoft.android.framwork.GameView;

public class GameScene extends BallAnimationScene
{
  /** őp`͂ɂd͂15{̉x^ */
  private static final float PUNCH_ACCELERATION = GRAVITY * 15;
  /** ǂꂾ̎ԃp`͂{[ɗ^邩?  */
  private static final int PUNCH_MSECOND = 50;
  /** XRA(hu */
  private int dribbled;
  /** vCc */
  private final static long TIME = 15;
  /** Q[Jn */
  private long gameStarted;
  /** c */
  private long remainedTime;
  /** XRA */
  private Paint paintScore;
  /** c莞 */
  private Paint paintRemainTime;
  /** ^b`uԂXW */
  private float downedX = 0;
  /** ^b`uԂYW */
  private float downedY = 0;

  public void init(GameView view) {
    super.init(view);

    paintScore = new Paint();
    paintScore.setTextAlign(Paint.Align.LEFT);
    paintScore.setAntiAlias(true);
    paintScore.setColor(Color.WHITE);
    paintScore.setTextSize(32);

    paintRemainTime = new Paint();
    paintRemainTime.setTextAlign(Paint.Align.RIGHT);
    paintRemainTime.setAntiAlias(true);
    paintRemainTime.setColor(Color.WHITE);
    paintRemainTime.setTextSize(32);
  }

  public void start(GameView view)
  {
    super.start(view);
    dribbled = 0;
    gameStarted = System.currentTimeMillis();
  }

  public void process(GameView view) 
  {
    remainedTime = TIME - (System.currentTimeMillis() - gameStarted) / 1000;
    if (remainedTime < 0) {
      Dribble.lastScore = dribbled;
      view.startScene(DribbleScenes.OVER);
      return;
    }
    MotionEvent event;
    while ((event = view.event()) != null) {
      switch (event.getAction()) {
      case MotionEvent.ACTION_DOWN:
        downedX = event.getX();
        downedY = event.getY();
        break;
      case MotionEvent.ACTION_UP:
        final float movedX = event.getX() - downedX;
        final float movedY = event.getY() - downedY;
        final float moved = Math.abs(movedX) + Math.abs(movedY);
        final float actionedX;
        final float actionedY;
        if (moved < 32) {
          Log.d("Dribble", "PUSH");
          actionedX = 0;
          actionedY = PUNCH_ACCELERATION;
        } else {
          Log.d("Dribble", "MOVE");
          actionedX = PUNCH_ACCELERATION * movedX / view.getWidth();
          actionedY = PUNCH_ACCELERATION * movedY / view.getHeight();
        }
        float A = PUNCH_MSECOND / GameView.MILLIS_PER_FRAME; 
        ballVX += actionedX * A / GameView.FRAMES_PER_SECOND;
        ballVY += actionedY * A / GameView.FRAMES_PER_SECOND;
        break;
      }
    }
    super.process(view);
  }

  @Override public void onDribbled() {
    dribbled++;
  }

  public void draw(Canvas canvas) 
  {
    super.draw(canvas);

    canvas.drawText(dribbled + " ", 0, 48, paintScore);
    canvas.drawText(" " + remainedTime + "b", canvas.getWidth(), 48, paintRemainTime);
  }

}

