package com.spicysoft.sample.dribble;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.MotionEvent;

import com.spicysoft.android.framwork.GameView;

public class OverScene extends BallAnimationScene
{
  private final static long WAIT = 2000;
  private final static long AUTO = 10000;
  private Paint paintScore;
  private long start;

  public void init(GameView view) 
  {
    super.init(view);

    paintScore = new Paint();
    paintScore.setTextAlign(Paint.Align.CENTER);
    paintScore.setAntiAlias(true);
    paintScore.setColor(Color.WHITE);
    paintScore.setTextSize(48);

  }

  public void start(GameView view)
  {
    start = System.currentTimeMillis();
  }

  public void process(GameView view)
  {
    final long elapsed = System.currentTimeMillis() - start;
    final MotionEvent e = view.event();
    if (WAIT < elapsed && e != null && e.getAction() == MotionEvent.ACTION_UP || AUTO <= elapsed) {
      view.startScene(DribbleScenes.TITLE);
    }
    super.process(view);
  }

  public void draw(Canvas canvas)
  {
    super.draw(canvas);
    canvas.drawText("L^ " + Dribble.lastScore + " ", canvas.getWidth() / 2, canvas.getHeight() / 2, paintScore);
  }
}

