package com.spicysoft.sample.dribble;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.MotionEvent;

import com.spicysoft.android.framwork.GameView;

public class TitleScene extends BallAnimationScene
{
  /** 1bœ_ł */
  private static final long BLINK_DURATION = 2000;
  /** _ŃAj[V̊Jn */
  private long blinkStarted;
  private Paint titlePaint;
  private Paint msgPaint;

  public void init(GameView view) {
    super.init(view);

    titlePaint = new Paint();
    titlePaint.setTextSize(48);
    titlePaint.setAntiAlias(true);
    titlePaint.setColor(Color.WHITE);
    titlePaint.setTextAlign(Paint.Align.CENTER);
    msgPaint = new Paint();
    msgPaint.setTextSize(24);
    msgPaint.setAntiAlias(true);
    msgPaint.setColor(Color.WHITE);
    msgPaint.setTextAlign(Paint.Align.CENTER);
  }

  public void start(GameView view) {
    super.start(view);
    blinkStarted = System.currentTimeMillis();
  }

  public void process(GameView view) {
    final MotionEvent e = view.event();
    if (e != null && e.getAction() == MotionEvent.ACTION_UP) {
      view.startScene(DribbleScenes.GAME);
    }
    super.process(view);
  }

  public void draw(Canvas canvas) {
    super.draw(canvas);

    final int w = canvas.getWidth();
    final int h = canvas.getHeight();

    canvas.drawText("Dribble", w / 2, h / 2, titlePaint);

    final long elapsed = (System.currentTimeMillis() - blinkStarted)
        % BLINK_DURATION;
    final int g;
    if (elapsed <= BLINK_DURATION / 2) {
      g = (int) (255 * elapsed / (BLINK_DURATION / 2));
    } else {
      g = (int) (255 * (BLINK_DURATION - elapsed) / (BLINK_DURATION / 2));
    }
    msgPaint.setColor(Color.rgb(g, g, g));
    canvas.drawText("Touch to Start!", w / 2, h / 2 + 48, msgPaint);
  }

}
