package com.spicysoft.android.framwork;

import java.util.LinkedList;
import java.util.Queue;

import android.content.Context;
import android.graphics.Canvas;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;


/**
 * Q[IuWFNg̏A^b`̏Aʂ̕\̃Q[̊{sNX
 */
public class GameView extends SurfaceView implements Runnable, SurfaceHolder.Callback
{
  /** FPS 1b̃t[BQ[̏P */
  public static final int FRAMES_PER_SECOND = 50;
  /** t[̃~b */
  public static final int MILLIS_PER_FRAME = 1000 / FRAMES_PER_SECOND;
  /** Xbh */
  private static Thread thread;
  /** Q[̃V[ */
  private Scenes scenes;
  /** V[ */
  private static Scene current;
  /** CxgL[ */
  private final Queue<MotionEvent> events  = new LinkedList<MotionEvent>();

  /** RXgN^ */
  public GameView(final Context context,final Scenes scenes) {
    super(context);
    this.scenes = scenes;
    setFocusable(true);
    getHolder().addCallback(this);
  }

  /** \(ʃTCY])ύXꂽۂAPIR[obN */
  @Override public void surfaceChanged(SurfaceHolder holder, int format,
      int width, int height) {
    Log.d("Dribble", "surfaceChanged");
  }

  /** ۂSurfaceViewꂽۂAPIR[obN */
  @Override public void surfaceCreated(SurfaceHolder holder) {
    Log.d("Dribble", "surfaceCreated");
    thread = new Thread(GameView.this);
    thread.start();
  }

  /** SurfaceViewjꂽۂɁAAPIR[obN*/
  @Override public void surfaceDestroyed(SurfaceHolder holder) {
    Log.d("Dribble", "surfaceDestroyed");
    thread.interrupt();
  }

  /** Q[[v̂Pt[̏ */
  @Override public void run() {
    Log.d("Dribble", "#run start");
    for(final Scene scene : scenes.scenes()) {
      scene.init(this);
    }

    startScene(scenes.bootScene());
    
    while(!thread.isInterrupted()) {
      final long start = System.currentTimeMillis();
      final Scene scene = current;
      scene.process(this);

      // (1) _uobt@OJn
      final SurfaceHolder holder = getHolder();
      final Canvas canvas = holder.lockCanvas();
      if (canvas != null) {
        try {
          scene.draw(canvas);
        } finally {
          // (3) _uobt@O
          holder.unlockCanvasAndPost(canvas);
        }
      }

      final long elapsed = System.currentTimeMillis() - start;
      final long towait = MILLIS_PER_FRAME - elapsed;
      if (0 < towait) {
          try {
            Thread.sleep(towait);
          } catch (final InterruptedException e) {
            Log.d("Dribble", "Thread#sleep",e);
            break;
          }
      }
    }
    Log.d("Dribble", "#run end");
    thread = null;
  }

  public MotionEvent event() {
   return events.poll(); 
  }

  /**
   * ^b`ꂽۂAPIR[obN
   * Q[[vŏł悤ɁA
   * [U^b`̓tbÑANVƁA
   * ̍ۂɂǂꂮ炢{[ɉe^ANVL^
   */
  @Override public boolean onTouchEvent(final MotionEvent event) {
    events.add(event);
    return true;
  }

  /**
   * V[ύX
   */
  public void startScene(final Scene scene) {
    current = scene;
    events.clear();
    current.start(this);
  }
}